>From 6742d313363aac2573164411cebf6424318c333f Mon Sep 17 00:00:00 2001
Message-Id:
From: Stefano Lattarini
Date: Fri, 6 Jul 2012 09:59:23 +0200
Subject: [PATCH 1/2] coverage: test that AM_PROG_MKDIR_P and $(mkdir_p) still
works
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
They are deprecated, but should continue to work in the 1.12.x
release series. Report from Benoit Sigoure and Diego Elio Pattenò:
* t/mkdirp-deprecation.sh: Enhance.
* t/mkdir_p.sh: New test, check that AM_INIT_AUTOMAKE still defines
the $(mkdir_p) make variable. Currently xfailing.
* t/list-of-tests.mk (handwritten_TESTS, XFAIL_TESTS): Add the new
test.
Signed-off-by: Stefano Lattarini
---
t/list-of-tests.mk | 2 ++
t/mkdir_p.sh | 44 ++++++++++++++++++++++++++++++++++++++++++++
t/mkdirp-deprecation.sh | 31 +++++++++++++++++++++++++------
3 files changed, 71 insertions(+), 6 deletions(-)
create mode 100755 t/mkdir_p.sh
diff --git a/t/list-of-tests.mk b/t/list-of-tests.mk
index 852b87a..61ac5c1 100644
--- a/t/list-of-tests.mk
+++ b/t/list-of-tests.mk
@@ -38,6 +38,7 @@ t/override-conditional-2.sh \
t/dist-pr109765.sh \
t/instdir-cond2.sh \
t/java-nobase.sh \
+t/mkdir_p.sh \
t/objext-pr10128.sh \
t/parallel-tests-many.sh \
t/pr8365-remake-timing.sh \
@@ -688,6 +689,7 @@ t/missing5.sh \
t/missing6.sh \
t/am-missing-prog.sh \
t/missing-auxfile-stops-makefiles-creation.sh \
+t/mkdir_p.sh \
t/mkdirp-deprecation.sh \
t/mkinstall.sh \
t/mkinst2.sh \
diff --git a/t/mkdir_p.sh b/t/mkdir_p.sh
new file mode 100755
index 0000000..9f03cf5
--- /dev/null
+++ b/t/mkdir_p.sh
@@ -0,0 +1,44 @@
+#! /bin/sh
+# Copyright (C) 2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see .
+
+# AM_INIT_AUTOMAKE should still define $(mkdir_p), for backward
+# compatibility.
+
+. ./defs || exit 1
+
+echo AC_OUTPUT >> configure.ac
+
+cat > Makefile.am << 'END'
+.PHONY: test
+check-local: test
+test:
+ $(mkdir_p) . dir1/dir2
+## $(mkdir_p) should continue to work even if we chdir around.
+ (mkdir x && cd x && $(mkdir_p) .. y/z ../foo)
+ test -d foo
+ test -d dir1/dir2
+ test -d x/y/z
+END
+
+$ACLOCAL
+$AUTOCONF -Werror -Wobsolete
+$AUTOMAKE
+
+./configure
+$MAKE test
+$MAKE distcheck
+
+:
diff --git a/t/mkdirp-deprecation.sh b/t/mkdirp-deprecation.sh
index 8482dea..9f41250 100755
--- a/t/mkdirp-deprecation.sh
+++ b/t/mkdirp-deprecation.sh
@@ -14,13 +14,28 @@
# You should have received a copy of the GNU General Public License
# along with this program. If not, see .
-# Check that the AM_PROG_MKDIR_P macro is deprecated. It will be
-# be removed in the next major Automake release.
+# Check that the AM_PROG_MKDIR_P macro is deprecated; it will be
+# be removed in the next major Automake release. But also check
+# that it still works as expected in the current release series.
. ./defs || exit 1
-echo AM_PROG_MKDIR_P >> configure.ac
-: > Makefile.am
+cat >> configure.ac << 'END'
+AM_PROG_MKDIR_P
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+.PHONY: test
+check-local: test
+test:
+ $(mkdir_p) . dir1/dir2
+## $(mkdir_p) should continue to work even if we chdir around.
+ (mkdir x && cd x && $(mkdir_p) .. y/z ../foo)
+ test -d foo
+ test -d dir1/dir2
+ test -d x/y/z
+END
grep_err ()
{
@@ -38,11 +53,15 @@ grep_err
$AUTOCONF -Werror -Wno-obsolete
-#AUTOMAKE_fails
-#grep_err
+AUTOMAKE_fails
+grep_err
AUTOMAKE_fails --verbose -Wnone -Wobsolete
grep_err
$AUTOMAKE -Wno-obsolete
+./configure
+$MAKE test
+$MAKE distcheck
+
:
--
1.7.9.5